#ifndef JACC_H
#define JACC_H

enum {
	NONE 	= 0x00,
	STREAM,
	AUTH,
	ERROR,
	MESSAGE,
	MESSAGE_INNER,
	MESSAGE_HTML,
	PRESENCE,
	PRESENCE_STATUS,
	PRESENCE_SHOW,
	PRESENCE_ERROR,
	PRESENCE_X,
	PRESENCE_SET,
	IQ,
	IQ_INNER,
	IQ_ITEM,
	IQ_GROUP,
	IQ_VCARD,
	IQ_VCARD_INNER,
	IQ_ERROR,
	IQ_DISCO,
	IQ_DISCO_IDENT,
	IQ_DISCO_FEATU,
	IQ_DISCO_ITEM,
	IQ_DISCO_EMPTY,
	IQ_VERSION,
	IQ_VERSION_OS,
	IQ_VERSION_NAME,
	IQ_VERSION_VER,
	IQ_TIME,
	IQ_TIME_UTC,
	IQ_TIME_TZ,
	IQ_TIME_DISPLAY,
	IQ_AGENTS,
	IQ_AGENTS_AGENT,
	IQ_AGENTS_NAME,
	IQ_AGENTS_DESC,
	IQ_AGENTS_SERV,
	IQ_LAST,
	ROSTER,
	ROSTER_INNER,
	ROSTER_GROUP,
	END
};

int xmljacc(int sock);
int loginjacc(int sock, char *serv);
int userjacc(int sock, char *user, char *pass, char *res);
int versionjacc(int sock, char *from, char *to, char *id);
int featuresjacc(int sock, char *from, char *to, char *id);
int timejacc(int sock, char *from, char *to, char *id);
int lastjacc(int sock, char *from, char *to, char *id, int d);
int registerjacc(int sock, char *serv, char *user, char *pass);
int vcardgetjacc(int sock, char *from, char *type);
int vcardsetjacc(int sock, char *from, int fd);
int presencejacc(int sock, char *stat, char *show, char *from, char *to);
int presencetypejacc(int sock, char *from, char *to, char *type);
int rosterjacc(int sock);
int messagejacc(int sock, char *from, char *to, char *msg, char *type);
int addbuddyjacc(int sock, char *jid, char *na, char *type);
int delbuddyjacc(int sock, char *jid);
int xmlnsjacc(int sock, char *who, char *t, char *id);

#endif

