#ifndef ROSTER_H
#define ROSTER_H

typedef struct rostern rostern;
struct rostern {
	rostern *n;
	rostern *p;
	char *name;
	char *jid;
	char *status;
	char *show;
	char *subsc;
	char *group;
};

typedef struct jabberc jabberc;
struct jabberc {
	char *stat;
	char *show;
	char *name;
	char *reso;
	char *serv;
	char *jid;
	int debug;
	int reg;
	int last;
	rostern *rost;
};

void freerostern(rostern *r);
void freerosterl(rostern *r);
void freejabberc(jabberc *j);
rostern *mkrostern(void);
jabberc *mkjabberc(void);
rostern *delrostern(rostern *r);
rostern *lastrostern(rostern *r);
rostern *addrostern(rostern *r, rostern *n);
rostern *statusrostern(rostern *r, char *name, char *jid, char *status, char *show);
char *namerostern(rostern *r, char *jid, char *name);
rostern *searchrostern(rostern *r, char *name, char *jid);
rostern *delname(rostern *r, char *name, char *jid);

#endif
